Prime Path(poj 3126)

时间:2022-09-13 00:01:14

Description

Prime Path(poj 3126)The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.  — It is a matter of security to change such things every now and then, to keep the enemy in the dark.  — But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!  — I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.  — No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!  — I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.  — Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 
Now, the minister of finance, who had been eavesdropping, intervened.  — No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.  — Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?  — In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033 1733 3733 3739 3779 8779 8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0 题目大意:问输入的第一个数金过几次变换可以得到第二个数;
变换时,每次只能改变一个数字;
经过变换得到的数字必须是素数;
不能完成输出Impossible;
 #include<iostream>
#include<cstring>
#include<cstdio>
#include<queue>
using namespace std;
bool pr[],vis[];
int a,b,t,i,j;
struct node
{
int a,step;
}p,q;
void pri()
{
memset(pr,-,sizeof(pr));
pr[]=pr[]=;
for(i=; i<; i++)
{
if(pr[i])
for(j=*i; j<; j+=i)
pr[j]=;
}
}
int change(int x,int i,int j)
{//方便改变数字的每一位,x是原数字,i代表第几位i=1是个位,j是改编成几(0————9,千位不能为0)
if(i==) return (x/)*+j;
else if(i==) return (x/)*+x%+j*;
else if(i==) return (x/)*+x%+j*;
else if(i==) return (x%)+j*;
}
void bfs()//简单bfs
{
queue<node>que;
p.a=a;
p.step=;
vis[a]=;
que.push(p);
while(!que.empty())
{
p=que.front();
que.pop();
q.step=p.step+;
for(i=; i<; i++)
for(j=; j<; j++)
{
if(i==&&j==)
continue;
q.a=change(p.a,i,j);
if(q.a==b)
{
printf("%d\n",q.step);
return;
}
if(pr[q.a]&&!vis[q.a])
{
que.push(q);
vis[q.a]=;
}
}
}
printf("Impossible\n");
}
int main()
{
pri();//素数筛初始化
scanf("%d",&t);
while(t--)
{
memset(vis,,sizeof(vis));//初始化
scanf("%d %d",&a,&b);
if(a==b){printf("0\n");continue;}//a==b情况单独处理;
bfs();
}
return ;
}